@echo off
:
: Initialise for striping HTML tags
:
set DEBUG=OFF
set WORD=%1
set STEX_DIR=C:\STEX
if %DEBUG%==ON (
    set TOP_DIR=.
    set IN_FILE=test3.txt
) else (
    set TOP_DIR=%STEX_DIR%\DICT
    set IN_FILE=dict.txt
)
:
: Save current directory and change to STEX directoty
:
set SAVE_CD=%cd%
CD /D %TOP_DIR%
:
set IN_PATH=%TOP_DIR%\%IN_FILE%
set CURL=%TOP_DIR%\curl.exe
set S=sed
set STRIPCAMB=%TOP_DIR%\stripcamb.exe
set STRIPBLANK=%TOP_DIR%\stripblank.exe
set STRIPEXT=%TOP_DIR%\stripext.exe
set STRIPLF=%TOP_DIR%\striplf.exe
set ICONV=%TOP_DIR%\iconv.exe
set TEMP_PATH=%TOP_DIR%\t$001.txt
set COUNT_PATH=%TOP_DIR%\countbytes.exe
set EDITOK=%STEX_DIR%\editok.exe
set ERROR=%TOP_DIR%\ErrorBox.exe
:
: Transfer the URL and strip HTML tags
:
%CURL% -s https://dictionary.cambridge.org/dictionary/english/%WORD% | ^
%STRIPCAMB% | %S% -e "/Your browser/d" -e "s/prepo/ prepo/g" | ^
%S% -e "s/noun/ noun/g" -e "s/verb/ verb/g" -e "s/adverb/ adverb/g" | ^
%S% -e "s/ad verb/ ad verb/g" -e "s/conjunction/ conjunction/g" | ^
%S% -e "s/pro noun/ pro noun/g" -e "s/adjective/ adjective/g" | ^
%S% -e "/{/d" -e "/}/d" -e "s/\./. /g" | ^
%S% -e "s/\. \"/.\"/g" -e "s/  / /g" -e "s/ )/)/g" -e "s/   *   //g" | ^
%S% -e "/See more/d" -e "/Want to learn/d" -e "/^    Improve/d" | ^
%S% -e "/^Wrong/d" -e "/^See all/d" -e "s/    //g" -e "/^strong \//d" | ^
%STRIPBLANK% | %S% -e "s/determiner/ determiner/" | ^
%S% -e "s/&#...;//" -e "/^\//d" -e "s/\?/? /g" -e "s/^%WORD%/\n%WORD%/" | ^
%S% -e "/^From /d" -e "/^(Definition of/d" | ^
%S% -e "/^ Cambridge University Press)/d" -e "/^These examples are from/d" | ^
%S% -e "s/^Fewer examples//g" | ^
%S% -e "/^This example is from /d" -e "/Hansard/d" | ^
%S% -e "/yImages/d" -e "/^ us/d" -e "/^Translations of/,$d" | ^
%S% -e "s/exclamation/ exclamation/" -e "/^Test your vocabulary/,$d" | ^
%STRIPLF% | %STRIPEXT% | %S% -e "s/suffix/ suffix/g" -e "s/^  //g" | ^
%ICONV% -s -c -f UTF-8 -t CP1252 > %IN_PATH%
:
: Get the size in bytes of the striped data file
:
TYPE %IN_PATH% | %COUNT_PATH% > %TEMP_PATH%
for /f "delims=." %%i in ('TYPE %TEMP_PATH%') do (
    set BYTES=%%i
)
DEL %TEMP_PATH%
:
: If bytes is positive with "Meaning" then display the results
:
%S% -n 1p %IN_PATH% > %TEMP_PATH%
SET /p STRING=<%TEMP_PATH%
if not defined STRING SET STRING=Empty
DEL %TEMP_PATH%
if %BYTES% GTR 0 (
    if %STRING:~0,7%==Meaning (
        CD /D %SAVE_CD%
        start %EDITOK% %IN_PATH%
    ) else (
        echo %WORD% is not in the dictionary yet - BETA
        start %ERROR% DictOK %WORD% is not in the dictionary yet - BETA
        call %TOP_DIR%\beta.bat %WORD%
    )
) else (
    echo No dictionary web page exists for %WORD%
    start %ERROR% DictOK No dictionary web page exists for %WORD%
  )
)
:
: Restore current directory
:
CD /D %SAVE_CD%
exit
