@echo off
:
: Initialise for striping HTML tags
:
set DEBUG=OFF
set WORD=%1
set STEX_DIR=C:\STEX
set IN_FILE=exam.txt
set WORK_FILE=work.txt
if %DEBUG%==ON (
    set TOP_DIR=.
) else (
    set TOP_DIR=%STEX_DIR%\DICT
)
:
: Save current directory and change to STEX directoty
:
set SAVE_CD=%cd%
CD /D %TOP_DIR%
:
set IN_PATH=%TOP_DIR%\%IN_FILE%
set WORK_PATH=%TOP_DIR%\%WORK_FILE%
set CURL=%TOP_DIR%\curl.exe
set S=sed
set STRIPHTML=%TOP_DIR%\striphtml.exe
set STRIPBLANK=%TOP_DIR%\stripblank.exe
set STRIPEXT=%TOP_DIR%\stripext.exe
set STRIPLF=%TOP_DIR%\striplf.exe
set ICONV=%TOP_DIR%\iconv.exe
set TEMP_PATH=%TOP_DIR%\t$003.txt
set COUNT_PATH=%TOP_DIR%\countbytes.exe
set EDITOK=%STEX_DIR%\editok.exe
set ERROR=%TOP_DIR%\ErrorBox.exe
:
: Transfer the URL and strip HTML tags
:
%CURL% -s https://dictionary.cambridge.org/example/english/%WORD% | ^
%STRIPHTML% | %S% -e "0,/Examples of /d" | ^
%S% -e "/{/d" -e "/}/d" -e "s/\./. /g" | ^
%S% -e "s/\. \"/.\"/g" -e "s/  / /g" -e "s/ )/)/g" -e "s/   *   //g" | ^
%S% -e "/See more/d" -e "/Want to learn/d" -e "/^    Improve/d" | ^
%S% -e "/^Wrong/d" -e "/^See all/d" -e "s/    //g" -e "/^strong \//d" | ^
%STRIPBLANK% | ^
%S% -e "s/&#...;//" -e "/^\//d" -e "s/\?/? /g" -e "s/^%WORD%/\n%WORD%/" | ^
%S% -e "/^From /d" -e "/^(Definition of/d" | ^
%S% -e "/^ Cambridge University Press)/d" -e "/^These examples are from/d" | ^
%S% -e "s/^Fewer examples//g" | ^
%S% -e "/^This example is from /d" -e "/Hansard/d" | ^
%S% -e "/yImages/d" -e "/^ us/d" -e "/^Translations of/,$d" | ^
%S% -e "/^Test your vocabulary/,$d" | ^
%STRIPLF% | %STRIPEXT% | %S% -e "s/^  //g" | ^
%ICONV% -s -c -f UTF-8 -t CP1252 > %WORK_PATH%
:
echo Examples of %WORD% > %IN_PATH%
TYPE %WORK_PATH% >> %IN_PATH%
:
: Get the size in bytes of the striped data file
:
TYPE %WORK_PATH% | %COUNT_PATH% > %TEMP_PATH%
for /f "delims=." %%i in ('TYPE %TEMP_PATH%') do (
    set BYTES=%%i
)
DEL %TEMP_PATH%
:
: If bytes is positive with "Examples" then display the results
:
%S% -n 1p %IN_PATH% > %TEMP_PATH%
SET /p STRING=<%TEMP_PATH%
if not defined STRING SET STRING=Empty
DEL %TEMP_PATH%
if %BYTES% GTR 0 (
    if %STRING:~0,8%==Examples (
        CD /D %SAVE_CD%
        start %EDITOK% %IN_PATH%
    ) else (
        echo No example for %WORD% found
        start %ERROR% DictOK No example for %WORD% found
    )
) else (
    echo No example web page exists for %WORD%
    start %ERROR% DictOK No example web page exists for %WORD%
  )
)
:
: Restore current directory
:
CD /D %SAVE_CD%
exit
